<template>
  <div class="account-offer-header">
    <div class="title">
      <div class="title__label">Персональное предложение</div>
      <div
        v-if="!isLoopingOffer"
        class="title__number"
      >
        {{ order.number }}
      </div>
    </div>
    <div class="price">
      <div class="price__value">
        <span>{{ order.totalPriceAmount.priceWithVat / 100 | currency }}</span>
        <i class="icon question" />
      </div>
      <div class="price__vat">
        <i
          v-if="isInternational"
          class="icon world international-icon"
          title="Международные перевозки, НДС 0%"
        />
        {{ order.totalPriceAmount.vatValue ? `В том числе НДС (${order.totalPriceAmount.vatRate}) ${formatNumber(order.totalPriceAmount.vatValue / 100)} ₽` : 'Не облагается НДС' }}
      </div>
    </div>
    <template v-if="order.status === 'NEW'">
      <div class="buttons">
        <div class="buttons__item">
          <ObButton
              label="Согласиться"
              :is-full-width="true"
              @click="acceptOffer"
          />
        </div>
        <div class="buttons__item">
          <ObButton
              label="Отказаться"
              type="outline"
              :is-full-width="true"
              @click="declineOffer"
          />
        </div>
      </div>
    </template>
    <template v-else-if="order.status === 'ACCEPTED'">
      <div class="status-block -caribbean-green">
        Вы согласились
      </div>
    </template>
    <template v-else-if="order.status === 'REFECTED'">
      <div class="status-block">
        Вы отказались<br>
        <span>{{ order.resultedAt | date('DD.MM.YYYY')}} в {{ order.resultedAt | date('HH:mm')}}</span>
      </div>
    </template>
    <div
      v-if="order.status === 'NEW'"
      class="indicators"
    >
      <Indicators :indicators="order"/>
    </div>
    <template v-if="isLoopingOffer">
      <div class="tabs">
        <ObTabs
          :value="{
            uuid: offerSuborderUuid
          }"
          :items="tabsItems"
          value-exp="uuid"
          :no-border="true"
          @on-change-tab="setOfferSuborderUuid"
        />
      </div>
      <div class="title mt30">
        <div class="title__number">
          {{ order.number }}
        </div>
      </div>
      <div class="price mt28">
        <div class="price__value">
          <span>{{ currentPrice }} ₽</span>
          <i class="icon question" />
        </div>
        <div class="price__vat">
          <i
            v-if="isInternational"
            class="icon world international-icon"
            title="Международные перевозки, НДС 0%"
          />
          <span>{{ currentVat }}</span>
        </div>
      </div>
      <div class="suborder-desc">
        Вам предлагают поехать по тарифу из договора. Подтвердите, если вы согласны.
      </div>
    </template>
  </div>
</template>

<script>
import Indicators from '../steps/top/indicators'
import ObButton from 'common-components/src/obComponents/obButton'
import ObTabs from 'common-components/src/obComponents/obTabs'
import {mapActions, mapGetters, mapMutations} from 'vuex'
import { formatNumber } from 'common-components/src/helpers/common'
import api from '@/api'

export default {
  name: 'AccountOfferHeader',
  components: {
    ObButton,
    ObTabs,
    Indicators
  },
  computed: {
    ...mapGetters({
      order: 'account/order',
      offerSuborderUuid: 'account/offerSuborderUuid'
    }),
    isLoopingOffer () {
      return Boolean(this.order.targetSuborderUuid && this.order.fromSuborderUuid)
    },
    tabsItems () {
      return [
        {
          title: 'Туда',
          uuid: 'targetSuborderUuid'
        },
        {
          title: 'Обратно',
          uuid: 'fromSuborderUuid'
        }
      ]
    },
    routeCategory () {
      return this.order.suborderSpecies?.routeCategory
    },
    isInternational () {
      return this.routeCategory === 'INTERNATIONAL'
    },
    currentPriceAmount () {
      const priceMap = {
        targetSuborderUuid: 'targetSuborderAmount',
        fromSuborderUuid: 'fromSuborderAmount'
      }

      return this.order[priceMap[this.offerSuborderUuid]]
    },
    currentPrice () {
      return formatNumber(this.currentPriceAmount.priceWithVat / 100)
    },
    currentVat () {
      return this.currentPriceAmount.vatValue ? `В том числе НДС ${formatNumber(this.currentPriceAmount.vatValue / 100)} ₽` : 'Не облагается НДС'
    },
    isExistResources () {
      return Boolean(this.order?.resources?.length)
    }
  },
  methods: {
    ...mapActions({
      setOfferSuborderUuid: 'account/setOfferSuborderUuid',
      getOrder: 'account/getOrder'
    }),
    ...mapMutations({
      loaderRightPanel: 'account/loaderRightPanel'
    }),
    formatNumber,
    async acceptOffer () {
      const messageText = this.isExistResources ? 'Заявка подписана, заказ перешел в' : 'Вы дали согласие, осталось подписать заявку, заказ перешел в'
      const messageLinkTitle = this.isExistResources ? 'Исполняемые заказы' : 'Назначение ресурсов'
      const messageLink = this.isExistResources ? 'requests__executed-orders' : 'requests__assigning_resources'

      try {
        this.loaderRightPanel(true)
        await api.accountOrder.changePersonalOfferStatus({ uuid: this.order.offerUuid, status: 'ACCEPTED' })

        setTimeout(() => {
          this.getOrder({ ...this.order, isAuto: true })
          this.$notification({
            type: 'snackbars',
            message: messageText,
            timeout: 6000,
            onclick: {
              label: messageLinkTitle,
              value: null,
              action: () => {
                window.open(`${window.location.origin}/${messageLink}`)
              }
            }
          })
        }, 1000)
      } catch (e) {
        console.log(e)
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка запроса`
        })
      }
    },
    async declineOffer () {
      try {
        this.loaderRightPanel(true)
        await api.accountOrder.changePersonalOfferStatus({ uuid: this.order.offerUuid, status: 'REJECTED' })

        setTimeout(() => {
          this.getOrder({ ...this.order, isAuto: true })
          this.$notification({
            type: 'snackbars',
            message: 'Вы отказались от персонального предложения, заказ перешел в',
            timeout: 6000,
            onclick: {
              label: 'Архив',
              value: null,
              action: () => {
                window.open(`${window.location.origin}/requests__order-archive`)
              }
            }
          })
        }, 1000)
      } catch (e) {
        console.log(e)
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка запроса`
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

@mixin box-shadow-line() {
  position: relative;
  &::after {
    content: '';
    position: absolute;
    bottom: -4px;
    left: -20px;
    width: calc(100% + 40px);
    height: 4px;
    background: linear-gradient(180deg, rgba(196, 213, 237, 0.5) 0%, rgba(207, 222, 244, 0) 100%);
    opacity: 0.5;
  }
}

.account-offer-header {
  text-align: center;
  @include box-shadow-line;
  .title {
    &__label {
      @include font-mixin(12px, 16px, 400, $shale-gray, 1.6px, uppercase);
    }
    &__number {
      @include font-mixin(12px, 16px, 400, $shale-gray, 1.6px, uppercase);
    }
  }
  .price {
    margin-top: 16px;
    padding-left: 10px;
    &__value {
      position: relative;
      display: flex;
      align-items: center;
      justify-content: center;
      padding-left: 12px;
      span {
        @include font-mixin(24px, 36px, 600);
      }
      .icon {
        margin-left: 10px;
        font-size: 12px;
        color: $gray-slate;
      }
    }
    &__vat {
      display: inline-flex;
      align-items: center;
      @include font-mixin(10px, 12px, 400, $gray-slate, 0.4px);
      .international-icon {
        margin-right: 7px;
        font-size: 14px;
        line-height: 14px;
        color: $color-blue-navy-blue;
      }
    }
  }
  .buttons {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    margin-top: 20px;
    &__item {
      width: 183px;
      &:not(:first-child) {
        margin-top: 10px;
      }
    }
  }
  .indicators {
    margin-bottom: 20px;
  }
  .tabs {
    display: flex;
    justify-content: center;
    margin-top: 20px;
    @include box-shadow-line;
    &::v-deep {
      .ob-tabs__container, .ob-tabs__panel {
        display: flex;
        justify-content: center;
        width: 100%;
      }
    }
  }
  .suborder-desc {
    margin-top: 20px;
    margin-bottom: 20px;
    @include font-mixin(14px, 18px, 400, $gray-slate);
  }
  .status-block {
    margin-top: 16px;
    margin-bottom: 16px;
    @include font-mixin(14px, 18px, 400, $color-grey-label);
  }
  .mt28 {
    margin-top: 28px !important;
  }
  .mt30 {
    margin-top: 30px !important;
  }
}
</style>
